-- Version 1.0
-- Strobes 
-- Author  Rockin' T

Strobes = {};
function Strobes.prerequisitesPresent(specializations)
    return true;
end;

function Srobes:load(savegame)
    local error = "Error: Strobes - %s (%s)";
    self.setState = SpecializationUtil.callSpecializationsFunction("setState");
    self.deactivate = SpecializationUtil.callSpecializationsFunction("deactivate");
    self.activate = SpecializationUtil.callSpecializationsFunction("activate");
    
    self.Strobes = {}; 
    local i = 0; local fin = false;
    while true do
        while true do
            local on = string.format("vehicle.lightsaddon.light(%d)",i);
            local lt = getXMLString(self.xmlFile, on .. "#type");
            if lt == nil then fin=true; break; end;
            local is = getXMLString(self.xmlFile, on .. "#index");
            if is == nil then
                print(string.format(error,"kein Index definiert",on));
                i=i+1;
                break;
            end;
            local index = Utils.indexToObject(self.components, is);
            if index == nil or index == 0 then
                print(string.format(error,"Index "..is.." nicht gefunden",on));
                i=i+1;
                break;
            end;
            
            local tl = {};
            tl.na = getXMLString(self.xmlFile, on .. "#inputName");
            tl.index = index;
            tl.so = Utils.getNoNil(getXMLBool(self.xmlFile, on .. "#stayOn"),false);
            if lt == "work" then
                tl.ds = Utils.getNoNil(getXMLBool(self.xmlFile, on .. "#defaultOn"),false);
            else
                tl.ds = false;
            end;
            tl.a = tl.ds;
            tl.ht = getXMLString(self.xmlFile, on .. "#helptext");
            local rl = getXMLString(self.xmlFile,on.."#real");
            if rl ~= nil then
                tl.rl = Utils.indexToObject(self.components, rl);
            end;
            local fl = getXMLString(self.xmlFile,on.."#beam");
            if fl ~= nil then
                tl.fl = Utils.indexToObject(self.components, fl);
            end;
            
            if lt == "strobe" then
                local sq = getXMLString(self.xmlFile, on.."#sequence");
                tl.ls = false;
                tl.ns = 0;
                tl.t = 1;
                if sq ~= nil then
                    tl.rnd = false;
                    tl.sq = {Utils.getVectorFromString(sq)};
                    tl.inv = Utils.getNoNil(getXMLBool(self.xmlFile, on.."#invert"),false);
                    tl.ls = tl.inv;
                    tl.ss = 1;
                else
                    tl.rnd = true;
                    tl.rndnn = Utils.getNoNil(getXMLInt(self.xmlFile, on.."#minOn"),100);
                    tl.rndxn = Utils.getNoNil(getXMLInt(self.xmlFile, on.."#maxOn"),100);
                    tl.rndnf = Utils.getNoNil(getXMLInt(self.xmlFile, on.."#minOff"),100);
                    tl.rndxf = Utils.getNoNil(getXMLInt(self.xmlFile, on.."#maxOff"),400);
                    math.randomseed( os.time() ); math.random();
                end;
            end;
            if self.Strobes[lt] == nil then
                self.Strobes[lt] = {};
            end;
            table.insert(self.Strobes[lt],tl);
            setVisibility(tl.index, false);
            if tl.fl ~= nil then
                setVisibility(tl.fl, false);
            end;
            if tl.rl ~= nil then
                setVisibility(tl.rl, false);
            end;
            i=i+1;
        end;
        if fin then break; end;
    end;

    if self.Strobes.work ~= nil then
        for i=1,table.getn(self.Strobes.work) do
            self:setState("work:"..i,self.Strobes.work[i].a,true);
        end;
    end;
    
    local flwp = getXMLFloat(self.xmlFile, "vehicle.lightsaddon.fillLevelWarning#percent");
    if flwp ~= nil and self.grainTankCapacity ~= nil then
        self.Strobes.flw = {};
        self.Strobes.flw.p = flwp;
        self.Strobes.flw.a = false;
    end;
    
    self.Strobes.ab = false;
    if table.getn(self.beaconLights) > 0 then
        local i=0;
        while true do
            local str = string.format("vehicle.beaconLights.beaconLight(%d)#",i);
            if getXMLString(self.xmlFile, str.."index") == nil then break end;
            local rotNode = getXMLString(self.xmlFile, str.."rotIndex");
            if rotNode ~= nil then
                self.beaconLights[i+1].rotNode = Utils.indexToObject(self.components, rotNode);
                self.beaconLights[i+1].rotSpeed = self.beaconLights[i+1].speed;
                self.beaconLights[i+1].speed = 0;
                self.Strobes.ab = true;
            end;
            i=i+1;
        end;
        self.Strobes.blso = Utils.getNoNil(getXMLBool(self.xmlFile, "vehicle.beaconLights#stayOn"),false);
    end;
    
    self.Strobes.sab = Utils.getNoNil(getXMLBool(self.xmlFile, "vehicle.lightsaddon#strobesAreBeacons"),false);
    if self.Strobes.strobe == nil then
        self.Strobes.sab = false;
    end;
    if self.Strobes.sab == true then
        for i=1,table.getn(self.Strobes.strobe) do
            self.Strobes.strobe.na = nil;
            self.Strobes.strobe.ht = nil;
        end;
    end;


    local bsf = getXMLString(self.xmlFile, "vehicle.lightsaddon.flashers#soundfile");
    if bsf ~= nil then
        self.Strobes.bss = createSample("flasherSound");
        loadSample(self.Strobes.bss, Utils.getFilename(bsf,self.baseDirectory), false);
        self.Strobes.bsl = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon.flashers#lowPitch"),0.8);
        self.Strobes.bsh = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon.flashers#highPitch"),1.0);
        self.Strobes.bsv = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon.flashers#volume"),1.0);
    end;
    self.Strobes.dar = Utils.getNoNil(getXMLBool(self.xmlFile,"vehicle.lightsaddon.flashers#autoreturn"),false);
    self.Strobes.art = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon.flashers#tolerance"),0.3);

    local tsf = Utils.getNoNil(getXMLString(self.xmlFile,"vehicle.lightsaddon.toggleSound#file"),"$dataS2/sounds/switchFlashlight.wav");
    local tsp = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon.toggleSound#pitch"),1.0);
    self.Strobes.tsv = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon.toggleSound#volume"),1.0);
    self.Strobes.tss = createSample("tss");
    loadSample(self.Strobes.tss, Utils.getFilename(tsf,self.baseDirectory), false);
    setSamplePitch(self.Strobes.tss, tsp);
    
    self.Strobes.lso = Utils.getNoNil(getXMLBool(self.xmlFile,"vehicle.lightsaddon#lightsStayOn"),false);
    self.Strobes.md = Utils.getNoNil(getXMLInt(self.xmlFile,"vehicle.lightsaddon#modDirection"),1);
    self.Strobes.bspd   = Utils.getNoNil(getXMLFloat(self.xmlFile,"vehicle.lightsaddon#blinkSpeed"),0.5) * 1000;
    
    self.Strobes.atv = nil;
    self.Strobes.setLA = false;
    self.Strobes.noRL = false;
    self.Strobes.wl = false;
    self.Strobes.blt = 0;
    self.Strobes.lsa = false;
    self.Strobes.bls = false;
    self.Strobes.left = false;
    self.deactivateLightsOnLeave = not self.Strobes.lso;
    if SpecializationUtil.hasSpecialization(Steerable, self.specializations) then
        self.Strobes.iSt = true;
    else
        self.Strobes.iSt = false;
    end;
    self.isSelectable = true;
end;

function STRB:delete()
    if self.Strobes.bss ~= nil then
        delete(self.Strobes.bss);
    end;
    if self.Strobes.tss ~= nil then
        delete(self.Strobes.tss);
    end;
end;

function STRB:mouseEvent(posX, posY, isDown, isUp, button)
end;

function STRB:keyEvent(unicode, sym, modifier, isDown)
end;

function STRB:readStream(streamId, connection)
    if self.Strobes.work ~= nil then
        for i=1,table.getn(self.Strobes.work) do
            self:setState("work:"..i,streamReadBool(streamId),true);
        end;
    end;
    if self.Strobes.strobe ~= nil then
        for i=1,table.getn(self.Strobes.strobe) do
            self:setState("strobe:"..i,streamReadBool(streamId),true);
        end;
    end;
    if self.Strobes.highbeam ~= nil then
        self:setState("highbeam",streamReadBool(streamId),true);
    end;
    if self.Strobes.dirLeft ~= nil and self.Strobes.dirRight ~= nil then
        self:setState("dirLeft",streamReadBool(streamId),true);
        self:setState("dirRight",streamReadBool(streamId),true);
        self:setState("warnlights",streamReadBool(streamId),true);
    end;
    if self.Strobes.parkLeft ~= nil and self.Strobes.parkRight ~= nil then
        self:setState("parkLeft",streamReadBool(streamId),true);
        self:setState("parkRight",streamReadBool(streamId),true);
    end;
end;

function STRB:writeStream(streamId, connection)
    if self.Strobes.work ~= nil then
        for k,v in pairs(self.Strobes.work) do
            streamWriteBool(streamId, v.a);
        end;
    end;
    if self.Strobes.strobe ~= nil then
        for k,v in pairs(self.Strobes.strobe) do
            streamWriteBool(streamId, v.a);
        end;
    end;
    if self.Strobes.highbeam ~= nil then
        streamWriteBool(streamId, self.Strobes.highbeam[1].a);
    end;
    if self.Strobes.dirLeft ~= nil and self.Strobes.dirRight ~= nil then
        streamWriteBool(streamId,self.Strobes.dirLeft[1].a);
        streamWriteBool(streamId,self.Strobes.dirRight[1].a);
        streamWriteBool(streamId,self.Strobes.wl);
    end;
    if self.Strobes.parkLeft ~= nil and self.Strobes.parkRight ~= nil then
        streamWriteBool(streamId,self.Strobes.parkLeft[1].a);
        streamWriteBool(streamId,self.Strobes.parkRight[1].a);
    end;
end;

function STRB:update(dt)
    local updateState = {};
    if self:getIsActiveForInput() then
        if self.Strobes.work ~= nil then
            for i=1,table.getn(self.Strobes.work) do
                local wl = self.Strobes.work[i];
                if InputBinding.hasEvent(InputBinding[wl.na]) and InputBinding[wl.na] ~= nil and wl.na ~= nil then
                    self:setState("work:"..i,not wl.a);
                    if self:getIsActiveForSound() then
                        playSample(self.Strobes.tss, 1, self.Strobes.tsv, 0);
                    end;
                end;
            end;
        end;
        if self.Strobes.strobe ~= nil then
            for i=1,table.getn(self.Strobes.strobe) do
                local sl = self.Strobes.strobe[i];
                if InputBinding.hasEvent(InputBinding[sl.na]) and InputBinding[sl.na] ~= nil and sl.na ~= nil then
                    self:setState("strobe:"..i,not sl.a);
                    if self:getIsActiveForSound() then
                        playSample(self.Strobes.tss, 1, self.Strobes.tsv, 0);
                    end;
                end;
            end;
        end;
        if self.Strobes.highbeam ~= nil then
            local hb = self.Strobes.highbeam[1];
            if InputBinding.isPressed(InputBinding.TOGGLE_LIGHTS) then
                if hb.cnt == nil then
                    hb.cnt = 0;
                    if not self.lightsActive then
                        self.Strobes.setLA = true;
                        self:setLightsVisibility(true);
                    end;
                else
                    if hb.blk == nil then 
                        hb.cnt = hb.cnt + dt;
                        self.Strobes.noRL = not hb.a;
                    end;
                end;
                if hb.cnt > 1500 and hb.blk == nil then
                    self:setState("highbeam", not hb.a);
                    self.Strobes.setLA = false;
                    self.Strobes.noRL = not hb.a;
                    hb.blk = true;
                end;
            else
                if hb.cnt ~= nil and hb.blk == nil then
                    if self.Strobes.setLA then
                        hb.a = false;
                        self.Strobes.setLA = false;
                        self:setLightsVisibility(false);
                        self:setState("highbeam", false);
                    else
                        self.Strobes.setLA = false;
                    end;
                end;
                hb.cnt = nil;
                hb.blk = nil;
            end;
        end;
        
        if self.Strobes.dirLeft ~=nil and self.Strobes.dirRight ~= nil then
            local dl = self.Strobes.dirLeft[1]; local dr = self.Strobes.dirRight[1];
            if not self.Strobes.wl then
                if InputBinding.hasEvent(InputBinding.STRBLEFT) then
                    if self:getIsActiveForSound() then
                        playSample(self.Strobes.tss, 1, self.Strobes.tsv, 0);
                    end;
                    self:setState("dirLeft",not dl.a);
                    self:setState("dirRight", false);
                end;
                if InputBinding.hasEvent(InputBinding.STRBRIGHT) then
                    if self:getIsActiveForSound() then
                        playSample(self.Strobes.tss, 1, self.Strobes.tsv, 0);
                    end;
                    self:setState("dirLeft", false);
                    self:setState("dirRight", not dr.a);
                end;
            end;
            if InputBinding.hasEvent(InputBinding.STRBWARN) then
                if self:getIsActiveForSound() then
                    playSample(self.Strobes.tss, 1, self.Strobes.tsv, 0);
                end;
                self:setState("warnlights",not self.Strobes.wl);
                self:setState("dirLeft",self.Strobes.wl);
                self:setState("dirRight",self.Strobes.wl);
            end;
        end;
    end;
    
    if self.Strobes.strobe ~= nil then
        for _,st in ipairs(self.Strobes.strobe) do
            if st.a then
                if st.t > st.ns then
                    st.ls = not st.ls;
                    setVisibility(st.index, st.ls);
                    st.t = 0;
                    if st.rnd then
                        if st.ls then
                            st.ns = math.random(st.rndnn,st.rndxn);
                        else
                            st.ns = math.random(st.rndnf,st.rndxf);
                        end;
                    else
                        st.ss = st.ss + 1; 
                        if st.ss > table.getn(st.sq) then st.ss = 1; end;
                        st.ns = st.sq[st.ss];
                    end;
                else
                    st.t = st.t + dt;
                end;
            end;
        end;
    end;
    
    if self.isServer and self:getIsActive() then
        if self.Strobes.brake ~= nil and self.Strobes.iSt then
            local iB = math.abs(Utils.sign(self.lastAcceleration)+ (-self.movingDirection*self.Strobes.md)) == 2;
            if self.Strobes.brake[1].a ~= iB then
                self:setState("brake",iB);
            end;
        end;
        if self.Strobes.reverse ~= nil then
            local iR = (self.movingDirection*self.Strobes.md) < 0;
            if self.Strobes.reverse[1].a ~= iR then         
                self:setState("reverse",iR);
            end;
        end;
    end;
    
    if self.Strobes.ab and self.Strobes.bla then
        for _,bl in ipairs(self.beaconLights) do
            if bl.rotNode ~= nil then
                rotate(bl.rotNode, 0, bl.rotSpeed*dt, 0);
            end;
        end;
    end;
    
end;

function STRB:updateTick(dt)

    if self.Strobes.dirLeft ~=nil and self.Strobes.dirRight ~= nil then
        local dl = self.Strobes.dirLeft; local dr = self.Strobes.dirRight;
        if dl[1].a or dr[1].a then
            if self.Strobes.blt > self.Strobes.bspd then
                self.Strobes.bls = not self.Strobes.bls;
                self.Strobes.blt = 0;
                if dl[1].a then
                    for _,b in pairs(dl) do
                        setVisibility(b.index,not self.Strobes.bls);
                    end;
                end;
                if dr[1].a then
                    for _,b in pairs(dr) do
                        setVisibility(b.index,not self.Strobes.bls);
                    end;
                end;
                --blinkersound
                if self:getIsActiveForSound() and self.Strobes.bss then
                    if self.Strobes.bls then
                        setSamplePitch(self.Strobes.bss, self.Strobes.bsl);
                    else
                        setSamplePitch(self.Strobes.bss, self.Strobes.bsh);
                    end;
                    playSample(self.Strobes.bss, 1, self.Strobes.bsv, 0);
                end;
            else
                self.Strobes.blt = self.Strobes.blt+dt;
            end;
            if self.Strobes.dar and not self.Strobes.wl then
                local rtp = math.abs(self.rotatedTime/self.maxRotTime);
                if not self.Strobes.lsa then
                    if rtp > self.Strobes.art then
                        self.Strobes.lsa = true;
                    end;
                else
                    if rtp < self.Strobes.art then
                        self.Strobes.lsa = false;
                        self:setState("dirLeft",false);
                        self:setState("dirRight",false);
                        if self:getIsActiveForSound() then
                            playSample(self.Strobes.tss, 1, self.Strobes.tsv, 0);
                        end;
                    end;
                end;
            end;
        else
            self.Strobes.blt = 0;
            if self.Strobes.bls == true then
                for _,b in pairs(dl) do
                    setVisibility(b.index,false);
                end;
                for _,b in pairs(dr) do
                    setVisibility(b.index,false);
                end;
                self.Strobes.bls = false;
            end;
        end;
    end;
    
    if self.Strobes.highbeam and self.realLightsActive then
        if self.Strobes.highbeam[1].a and not self.Strobes.noRL then
            for _,light in pairs(self.lights) do
                setVisibility(light,false);
            end;
            self.Strobes.noRL = true;
        elseif not self.Strobes.highbeam[1].a and self.Strobes.noRL then
            for _,light in pairs(self.lights) do
                setVisibility(light,true);
            end;
            self.Strobes.noRL = false;
        end;
    end;

    if self:getIsActive() and not self.Strobes.iSt and self.Strobes.atv ~= nil then
        local atvb = false;
        if self.Strobes.atv.Strobes ~= nil then 
            local atv = self.Strobes.atv.Strobes;
            if atv.brake ~= nil and self.Strobes.brake ~= nil then
                atvb = true;
                if self.Strobes.brake[1].a ~= atv.brake[1].a then
                    self:setState("brake",atv.brake[1].a,true);
                end;
            end;
            if atv.reverse ~= nil and self.Strobes.reverse ~= nil then
                if self.Strobes.reverse[1].a ~= atv.reverse[1].a then
                    self:setState("reverse",atv.reverse[1].a,true);
                end;
            end;
            if self.Strobes.dirLeft ~=nil and self.Strobes.dirRight ~= nil then
                if atv.wl ~= self.Strobes.wl then
                    self:setState("warnlights",not self.Strobes.wl);
                    self:setState("dirLeft",self.Strobes.wl);
                    self:setState("dirRight",self.Strobes.wl);
                else
                    if atv.dirLeft ~= nil and atv.dirRight ~= nil then
                        if atv.dirLeft[1].a ~= self.Strobes.dirLeft[1].a or atv.dirRight[1].a ~=  self.Strobes.dirRight[1].a then
                            self:setState("dirLeft", atv.dirLeft[1].a);
                            self:setState("dirRight", atv.dirRight[1].a);
                        end;
                    end;
                end;
            end;
        end;
        if not atvb and self.Strobes.brake ~= nil then
            local iB = math.abs(Utils.sign(self.Strobes.atv.lastAcceleration)+ (-self.movingDirection*self.Strobes.md)) == 2;
            if self.Strobes.brake[1].a ~= iB then
                self:setState("brake",iB);
            end;
        end;
    end;
    
    if self:getIsActive() then
        if self.Strobes.flw ~= nil then
            if not self.Strobes.flw.a then
                if self.grainTankFillLevel > 0 and not self.beaconLightsActive then
                    local p = self.grainTankFillLevel * 100 / self.grainTankCapacity;
                    if p >= self.Strobes.flw.p then
                        self:setBeaconLightsVisibility(true);
                        self.Strobes.flw.a = true;
                    end;
                end;
            else
                if self.beaconLightsActive then
                    local p = self.grainTankFillLevel * 100 / self.grainTankCapacity;
                    if p < self.Strobes.flw.p then
                        self:setBeaconLightsVisibility(false);
                        self.Strobes.flw.a = false;
                    end;
                end;
            end;
        end;

        self.Strobes.bla = self.beaconLightsActive;
        
        if self.Strobes.sab and self.Strobes.strobe ~= nil and self.beaconLightsActive ~= nil then
            if self.Strobes.strobe[1].a ~= self.beaconLightsActive then
                for i=1,table.getn(self.Strobes.strobe) do
                    self:setState("strobe:"..i, self.beaconLightsActive);
                end;
            end;
        end;

        if self.Strobes.drl ~= nil then
            if self.Strobes.drl[1].a == self.lightsActive then
                self:setState("drl", not self.lightsActive);
            end;
        end;

    end;
    
    if self.currentPipeState ~= nil and self.Strobes.pipe ~= nil then
        if (self.currentPipeState > 1) ~= self.Strobes.pipe[1].a then
            self:setState("pipe", self.currentPipeState > 1, true);
        end;
    end;
    
    if self.Strobes.bla and not self.beaconLightsActive then
        self:setBeaconLightsVisibility(true, true);
    end;
    
end;

function STRB:draw()
    if self.Strobes.work ~= nil then
        for i=1,table.getn(self.Strobes.work) do
            local wl = self.Strobes.work[i];
            if wl.ht ~= nil and wl.na ~= nil then
                g_currentMission:addHelpButtonText(g_i18n:getText(wl.ht), InputBinding[wl.na]);
            end;
        end;
    end;
    if self.Strobes.strobe ~= nil then
        for i=1,table.getn(self.Strobes.strobe) do
            local sl = self.Strobes.strobe[i];
            if sl.ht ~= nil and sl.na ~= nil then
                g_currentMission:addHelpButtonText(g_i18n:getText(sl.ht), InputBinding[sl.na]);
            end;
        end;
    end;
end;

function STRB:onAttach()
    local atv = self.attacherVehicle;
    self.Strobes.bbspd = self.Strobes.bspd;
    while true do 
        if atv.attacherVehicle ~= nil then
            atv = atv.attacherVehicle;
        else 
            break;
        end;
    end;
    self.Strobes.atv = atv;
    if atv.Strobes ~= nil then
        if atv.Strobes.bspd ~= nil then
            self.Strobes.bspd = atv.Strobes.bspd;
        end;
    end;
    if atv.beaconLightsActive then
        self:setBeaconLightsVisibility(atv.beaconLightsActive);
    end;
    self:activate();
end;

function STRB:onDetach()
    self.Strobes.atv = nil;
    if self.Strobes.bbspd ~= nil then
        self.Strobes.bspd = self.Strobes.bbspd;
    end;
    self:deactivate();
end;            

function STRB:onDeactivate()
    self:deactivate();
end;

function STRB:onLeave()
    self:deactivate();
end;

function STRB:deactivate()
    if self.Strobes.left then
        self.Strobes.left = false;
        return;
    else
        self.Strobes.left = true;
    end;
    if self.Strobes.work ~= nil then
        for i=1,table.getn(self.Strobes.work) do
            local wl = self.Strobes.work[i];
            local newstate = false;
            if wl.so then
                newstate = wl.a;
            end;
            self:setState("work:"..i,newstate,true);
        end;
    end;
    if self.Strobes.strobe ~= nil then
        for i=1,table.getn(self.Strobes.strobe) do
            local sl = self.Strobes.strobe[i];
            local newstate = false;
            if sl.so then
                newstate = sl.a;
            end;
            self:setState("strobe:"..i,newstate,true);
        end;
    end;

    if self.Strobes.highbeam ~= nil then
        self:setState("highbeam", false,true);
    end;
    
    if self.Strobes.flw ~= nil then
        self.Strobes.flw.a = false;
    end;

    if self.Strobes.lso then
        --koronas an , licht aus
        local la = self.lightsActive;
        if self.attacherVehicle ~= nil then
            la = self.attacherVehicle.lightsActive;
        end;
        if la then
            self:setLightsVisibility(false);
            if self.Strobes.parkLeft and self.Strobes.parkRight then
                self:setState("parkLeft",true);
                self:setState("parkRight",true);
            else
                for _, corona in pairs(self.lightCoronas) do
                    setVisibility(corona, true);
                end;
              end;
            end;
    end;

    if not self.Strobes.wl then
        if self.Strobes.dirLeft and self.Strobes.dirRight then
            if self.Strobes.parkLeft and self.Strobes.parkRight then
                if self.Strobes.dirLeft[1].a then
                    self:setState("parkLeft",true);
                end;
                if self.Strobes.dirRight[1].a then
                    self:setState("parkRight",true);
                end;
            end;
            if self.Strobes.dirLeft[1].a then
                self:setState("dirLeft",false);
            end;
            if self.Strobes.dirRight[1].a then
                self:setState("dirRight",false);
            end;
        end;
    end;
    
    if self.Strobes.brake then
        if self.Strobes.brake[1].a then
            self:setState("brake",false);
        end;
    end;
    if self.Strobes.reverse then
        if self.Strobes.reverse[1].a then
            self:setState("reverse",false);
        end;
    end;

    if self.Strobes.drl ~= nil then
        if self.Strobes.drl[1].a then
            self:setState("drl", false);
        end;
    end;

    if self.Strobes.bla and not self.Strobes.blso then
        self.Strobes.bla = false;
    end;
    
end;    

function STRB:onEnter()
    self:activate();
end;

function STRB:onActivate()
    self:activate();
end;

function STRB:activate()
    self.Strobes.left = false;
    if self.Strobes.work then
        for i=1,table.getn(self.Strobes.work) do
            local wl = self.Strobes.work[i];
            self:setState("work:"..i,wl.a,true);
        end;
    end;
    if self.Strobes.strobe then
        for i=1,table.getn(self.Strobes.strobe) do
            local sl = self.Strobes.strobe[i];
            self:setState("strobe:"..i,sl.a,true);
        end;
    end;
    if self.Strobes.parkLeft and self.Strobes.parkRight then
        if self.Strobes.parkLeft[1].a and self.Strobes.parkRight[1].a then
            self:setState("parkLeft",false);
            self:setState("parkRight",false);
            self:setLightsVisibility(true);
        end;
    end;
    if self.Strobes.dirLeft and self.Strobes.parkLeft then
        if self.Strobes.parkLeft[1].a then
            self:setState("dirLeft",true);
            self:setState("parkLeft",false);
        end;
    end;
    if self.Strobes.dirRight and self.Strobes.parkRight then
        if self.Strobes.parkRight[1].a then
            self:setState("dirRight",true);
            self:setState("parkRight",false);
        end;
    end;
    if self.lightCoronas ~= nil then
        if getVisibility(self.lightCoronas[1]) == true then
            self:setLightsVisibility(true);
        end;
    end;

    if self.Strobes.drl ~= nil then
        if self.Strobes.drl[1].a == false then
            self:setState("drl", true);
        end;
    end;

end;    

function STRB:setState(object,state,noEventSend)
    if object=="warnlights" then
        self.Strobes.wl = state;
        SetLightStateEvent.sendEvent(self,object,state,noEventSend);
        return;
    end;
    local o,c = unpack(Utils.splitString(":",object));
    local lt = self.Strobes[o];
    local cs = 1; local cm = table.getn(lt);
    if c ~= nil then
        cs = tonumber(c); cm = cs;
    end;
    for c=cs,cm do
        local l = lt[c];
        l.a = state;
        setVisibility(l.index,state);
        local rstate = false; 
        local bstate = false;

        local isEntered = self.isEntered;
        if self.Strobes.atv ~= nil then
            isEntered = self.Strobes.atv.isEntered;
        end;

        if isEntered == true then
            rstate = state;
        else
            bstate = state;
        end;
        if l.rl ~= nil then
            setVisibility(l.rl,rstate);
        end;
        if l.fl ~= nil then
            setVisibility(l.fl,bstate);
        end;
    end;

    SetLightStateEvent.sendEvent(self,object,state,noEventSend);
end;


SetLightStateEvent = {};
SetLightStateEvent_mt = Class(SetLightStateEvent, Event);

InitEventClass(SetLightStateEvent, "SetLightStateEvent");

function SetLightStateEvent:emptyNew()
    local self = Event:new(SetLightStateEvent_mt);
    self.className="SetLightStateEvent";
    return self;
end;

function SetLightStateEvent:new(object, light, state)
        local self = SetLightStateEvent:emptyNew()
        self.object = object;
        self.light = light;
        self.state = state;
        return self;
end;

function SetLightStateEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
        self.light  = streamReadString(streamId);
    self.state = streamReadBool(streamId);
    self:run(connection);
end;

function SetLightStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
        streamWriteString(streamId, self.light);
        streamWriteBool(streamId, self.state);
end;

function SetLightStateEvent:run(connection)
    self.object:setState(self.light,self.state, true);
  if not connection:getIsServer() then
      g_server:broadcastEvent(SetLightStateEvent:new(self.object, self.light, self.state), nil, connection, self.object);
  end;    
end;

function SetLightStateEvent.sendEvent(vehicle, light, state, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(SetLightStateEvent:new(vehicle, light, state), nil, nil, vehicle);
        else
            g_client:getServerConnection():sendEvent(SetLightStateEvent:new(vehicle, light, state));
        end;
    end;
end;

